/**
 * https://www.smashingmagazine.com/2019/03/robust-layouts-container-units-css/
 */

.container 
  margin-right: auto
  margin-left: auto
  padding-left: $unit
  padding-right: $unit
  
\:root
  --unit: 4.166666666666667vw
  @media (max-width: $mob)
    --unit: 24px

  // Grid proportions
  --grid-width: 1760
  --grid-column-width: 125
  --grid-columns: 12

  // Grid logic
  --grid-gutters: calc(var(--grid-columns) - 1)

  // Grid proportion logic
  --column-proportion: calc(var(--grid-column-width) / var(--grid-width))
  --gutter-proportion: calc((1 - (var(--grid-columns) * var(--column-proportion))) / var(--grid-gutters))

  // Container Units
  --column-unit: calc(var(--column-proportion) * var(--container-width))
  --gutter-unit: calc(var(--gutter-proportion) * var(--container-width))
  --column-and-gutter-unit: calc(var(--column-unit) + var(--gutter-unit))

  --container-width: calc(100vw - #{$unit-2})

@function unit-plus($fn)
  @return calc(#{$unit} + #{$fn})

@function unit-plus-2($fn)
  @return calc(#{$unit}/2 + #{$fn})

@function minus($fn)
  @return calc(-1 * #{$fn})

@function columns($i)
  @return calc(#{$i} * var(--column-unit))

@function gutters($i)
  @return calc(#{$i} * var(--gutter-unit))

@function column-spans($i)
  @return calc(#{$i} * var(--column-and-gutter-unit) - var(--gutter-unit))

@function gutter-spans($i)
  @return calc(#{$i} * var(--column-and-gutter-unit) - var(--column-unit))

@function mix($columns, $gutters: $columns)
  @return calc((#{$columns} * var(--column-unit)) + (#{$gutters} * var(--gutter-unit)))
